## org.eclipse.datatools.connectivity.oda.util.manifest
Class ManifestExplorer

    java.lang.Object
      org.eclipse.datatools.connectivity.oda.util.manifest.ManifestExplorer

public class ManifestExplorer
extends java.lang.Object

The Manifest Explorer is the entry point to explore and access the manifest of all the ODA plug-ins extensions that implement the `org.eclipse.datatools.connectivity.oda.dataSource` extension point. The `ManifestExplorer` singleton instance is retrieved using the `getInstance()` method.

Method Summary
`java.util.Properties` `getDataSourceIdentifiers()` Returns a collection of identifiers of all ODA data source extensions.
`ExtensionManifest` `getExtensionManifest(java.lang.String dataSourceId)` Returns the extension configuration information found in the plugin manifest file of the data source extension that contains the specified data source element and implements the DTP ODA run-time extension point - org.eclipse.datatools.connectivity.oda.dataSource.
`ExtensionManifest` `getExtensionManifest(java.lang.String dataSourceId, java.lang.String extensionPoint)` Returns the extension configuration information found in the plugin manifest file of the data source extension that contains the specified data source element and implements the specified ODA extension point.
`ExtensionManifest[]` `getExtensionManifests()` Returns an array of DTP ODA dataSource extension configuration information found in the plugin manifest file.
`ExtensionManifest[]` `getExtensionManifests(boolean includesAllExtensions)` Returns an array of DTP ODA dataSource extension configuration information found in the plugin manifest file.
`ExtensionManifest[]` `getExtensionManifests(java.lang.String extensionPoint)` Returns an array of ODA dataSource extension configuration information of those extensions that implement the specified extension point.
`ExtensionManifest[]` `getExtensionManifests(java.lang.String extensionPoint, boolean includesAllExtensions)` Returns an array of ODA dataSource extension configuration information of those extensions that implement the specified extension point.
`static IExtension[]` `getExtensions(java.lang.String extPoint)`
`static ManifestExplorer` `getInstance()` Gets the `ManifestExplorer` instance to explore the manifest of the data source extensions.
`static IConfigurationElement` `getNamedElement(IExtension extension, java.lang.String elementName)` Returns the configuration element of the given extension and element name.
`static IConfigurationElement[]` `getNamedElements(IExtension extension, java.lang.String elementName)` Returns a collection of configuration elements with the given name in the given extension.
`static IConfigurationElement[]` `getNamedElements(IExtension extension, java.lang.String elementName, java.lang.String requiredAttributeName)` Returns a collection of configuration elements with the given name in the given extension.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### getInstance

    public static ManifestExplorer getInstance()

  Gets the `ManifestExplorer` instance to explore the manifest of the data source extensions.

  Returns:
    the `ManifestExplorer` instance.

### getDataSourceIdentifiers

    public java.util.Properties getDataSourceIdentifiers()

  Returns a collection of identifiers of all ODA data source extensions. The extension's data source element ID and display name are stored as the key and value in the returned Properties instance. The returned collection includes all matching extensions, including those with no dataSet elements defined. Returns an empty `Properties` if there are no data source extensions found.

  Returns:
    a `Properties` containing the id and display name of all data source extensions.

### getExtensionManifest

    public ExtensionManifest getExtensionManifest(java.lang.String dataSourceId)
                                           throws OdaException

  Returns the extension configuration information found in the plugin manifest file of the data source extension that contains the specified data source element and implements the DTP ODA run-time extension point - org.eclipse.datatools.connectivity.oda.dataSource.

  Parameters:
    `dataSourceId` - the unique id of the data source element in a data source extension.
  Returns:
    the extension manifest information
  Throws:
    `OdaException` - if the extension manifest is invalid.
    `java.lang.IllegalArgumentException` - if no extension is found.

### getExtensionManifest

    public ExtensionManifest getExtensionManifest(java.lang.String dataSourceId,
                                                  java.lang.String extensionPoint)
                                           throws OdaException

  Returns the extension configuration information found in the plugin manifest file of the data source extension that contains the specified data source element and implements the specified ODA extension point.

  Parameters:
    `dataSourceId` - the unique id of the data source element in a data source extension.
    `extensionPoint` - the id of the extension point to search
  Returns:
    the extension manifest information, or null if no extension configuration is found.
  Throws:
    `OdaException` - if the extension manifest is invalid.

### getExtensionManifests

    public ExtensionManifest[] getExtensionManifests()

  Returns an array of DTP ODA dataSource extension configuration information found in the plugin manifest file. Includes all matching extensions, regardless of whether an extension has no dataSet elements defined. Returns an empty array if there are no data source extensions found. Invalid data source extension definitions are ignored.

  Returns:
    an `ExtensionManifest` array containing the definition of all matching ODA data source extensions.

### getExtensionManifests

    public ExtensionManifest[] getExtensionManifests(boolean includesAllExtensions)

  Returns an array of DTP ODA dataSource extension configuration information found in the plugin manifest file. The argument specifies whether to include all matching extensions, regardless of whether it has defined no dataSet element, such as a driver adapter plugin.

  Parameters:
    `includesAllExtensions` - true to include all matching extensions; false to include only those matching extensions with at least one valid dataSet element defined
  Returns:
    an `ExtensionManifest` array containing the definition of all matching ODA data source extensions.

### getExtensionManifests

    public ExtensionManifest[] getExtensionManifests(java.lang.String extensionPoint)

  Returns an array of ODA dataSource extension configuration information of those extensions that implement the specified extension point. Includes all matching extensions, regardless of whether an extension has no dataSet elements defined. Returns an empty array if there are no data source extensions found. Invalid data source extension definitions are ignored.

  Parameters:
    `extensionPoint` - name of an ODA data source extension point
  Returns:
    an `ExtensionManifest` array containing the definition of all matching ODA data source extensions.

### getExtensionManifests

    public ExtensionManifest[] getExtensionManifests(java.lang.String extensionPoint,
                                                     boolean includesAllExtensions)

  Returns an array of ODA dataSource extension configuration information of those extensions that implement the specified extension point. The argument specifies whether to include all matching extensions, regardless of whether it has defined no dataSet element, such as a driver adapter plugin.

  Parameters:
    `extensionPoint` - name of an ODA data source extension point
    `includesAllExtensions` - true to include all matching extensions; false to include only those matching extensions with at least one valid dataSet element defined
  Returns:
    an `ExtensionManifest` array containing the definition of all matching ODA data source extensions.

### getExtensions

    public static IExtension[] getExtensions(java.lang.String extPoint)

### getNamedElement

    public static IConfigurationElement getNamedElement(IExtension extension,
                                                        java.lang.String elementName)
                                                 throws OdaException

  Returns the configuration element of the given extension and element name.
  For internal use only.

  Throws:
    `OdaException`

### getNamedElements

    public static IConfigurationElement[] getNamedElements(IExtension extension,
                                                           java.lang.String elementName)
                                                    throws OdaException

  Returns a collection of configuration elements with the given name in the given extension. Validates that each element has an id attribute defined.

  Returns:
    a collection of matching configuration elements
    For internal use only.
  Throws:
    `OdaException`

### getNamedElements

    public static IConfigurationElement[] getNamedElements(IExtension extension,
                                                           java.lang.String elementName,
                                                           java.lang.String requiredAttributeName)
                                                    throws OdaException

  Returns a collection of configuration elements with the given name in the given extension. Validates that each element has the specified attribute defined.

  Returns:
    a collection of matching configuration elements
    For internal use only.
  Throws:
    `OdaException`

Copyright © 2006 Actuate, IBM Corporation, Sybase, Inc. and others. All rights reserved.